Subject: Re: Bad gcc-4.1.0 leads to Power4 crashes... and power5 too, actually

From: Peter Bergner <[email-masked]>
Date: Tue, 19 Dec 2006 19:46:50 -0600

On Tue, 2006-12-19 at 18:46 -0600, Linas Vepstas wrote:
> Per xchat, here's the update. I'm guessing I'm using a broken
> compiler, as per chain of evidence below ...
[snip]
> However, I also note that the following scrolled by:
> init/main.c:81:2: warning: #warning gcc-4.1.0 is known to miscompile the
> kernel. A different compiler version is recommended.

It may be due to this GCC bug which Olaf ran into a while back:

  http://gcc.gnu.org/bugzilla/show_bug.cgi?id=24644

You can verify whether you have a broken compiler by compiling
the minimal test case I posted in comment #15.  If you see r13
being copied into another register and then used, then you have
a broken compiler.

Peter